'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 13 March 2002 at 1:49:44 am'!

!ClassBuilder methodsFor: 'class definition' stamp: 'minami 3/11/2002 12:16'!
class: oldClass instanceVariableNames: instVarString unsafe: unsafe
    "This is the basic initialization message to change the definition of
    an existing Metaclass"
    | instVars newClass |
    environ _ oldClass environment.
    instVars _ Scanner new scanFieldNames: instVarString.
    unsafe ifFalse:[
        "Run validation checks so we know that we have a good chance for recompilation"
        (self validateInstvars: instVars from: oldClass forSuper: oldClass superclass) ifFalse:[^nil].
        (self validateSubclassFormat: oldClass typeOfClass from: oldClass forSuper: oldClass superclass extra: instVars size) ifFalse:[^nil]].
    "Create a template for the new class (will return oldClass when there is no change)"
    newClass _ self
        newSubclassOf: oldClass superclass
        type: oldClass typeOfClass
        instanceVariables: instVars
        from: oldClass
        unsafe: unsafe.

    newClass == nil ifTrue:[^nil]. "Some error"
    newClass _ self recompile: false from: oldClass to: newClass mutate: false.
    self doneCompiling: newClass.

    ClassDefinitionChangeList default addDefinition: newClass.

    ^newClass! !

!ClassBuilder methodsFor: 'class definition' stamp: 'minami 3/11/2002 12:16'!
name: className inEnvironment: env subclassOf: newSuper type: type instanceVariableNames: instVarString classVariableNames: classVarString poolDictionaries: poolString category: category unsafe: unsafe
    "Define a new class in the given environment.
    If unsafe is true do not run any validation checks.
    This facility is provided to implement important system changes."
    | oldClass newClass organization instVars classVars force |
    environ _ env.
    instVars _ Scanner new scanFieldNames: instVarString.
    classVars _ (Scanner new scanFieldNames: classVarString) collect: [:x | x asSymbol].

    "Validate the proposed name"
    unsafe ifFalse:[(self validateClassName: className) ifFalse:[^nil]].
    oldClass _ env at: className ifAbsent:[nil].
    oldClass isBehavior
        ifFalse:[oldClass _ nil]. "Already checked in #validateClassName:"

    unsafe ifFalse:[
        "Run validation checks so we know that we have a good chance for recompilation"
        (self validateSuperclass: newSuper forSubclass: oldClass) ifFalse:[^nil].
        (self validateInstvars: instVars from: oldClass forSuper: newSuper) ifFalse:[^nil].
        (self validateClassvars: classVars from: oldClass forSuper: newSuper) ifFalse:[^nil].
        (self validateSubclassFormat: type from: oldClass forSuper: newSuper extra: instVars size) ifFalse:[^nil]].

    "Create a template for the new class (will return oldClass when there is no change)"
    newClass _ self
        newSubclassOf: newSuper
        type: type
        instanceVariables: instVars
        from: oldClass
        unsafe: unsafe.

    newClass == nil ifTrue:[^nil]. "Some error"

    newClass == oldClass ifFalse:[newClass setName: className].

    "Install the class variables and pool dictionaries... "
    force _ (newClass declare: classVarString) | (newClass sharing: poolString).

    "... classify ..."
    organization _ environ ifNotNil:[environ organization].
    organization classify: newClass name under: category asSymbol.
    newClass environment: environ.

    "... recompile ..."
    newClass _ self recompile: force from: oldClass to: newClass mutate: false.

    "... export if not yet done ..."
    (environ at: newClass name ifAbsent:[nil]) == newClass ifFalse:[
        [environ at: newClass name put: newClass]
            on: AttemptToWriteReadOnlyGlobal do:[:ex| ex resume: true].
        Smalltalk flushClassNameCache.
    ].

    self doneCompiling: newClass.

    ClassDefinitionChangeList default addDefinition: newClass.

    ^newClass
! !

