Object subclass: #ClassDefinitionChangeList
	instanceVariableNames: 'classDefinitionContainerDictionary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Changes-Extension'!

!ClassDefinitionChangeList methodsFor: 'accessing' stamp: 'minami 3/13/2002 11:31'!
at: aClass
	^ self atClassNamed: aClass name asString! !

!ClassDefinitionChangeList methodsFor: 'accessing' stamp: 'minami 3/13/2002 11:48'!
at: aClass ifAbsent: aBlock 
	^ self atClassNamed: aClass name asString ifAbsent: aBlock! !

!ClassDefinitionChangeList methodsFor: 'accessing' stamp: 'minami 3/13/2002 11:48'!
atClassNamed: className 
	^ self classDefinitionContainerDictionary at: className! !

!ClassDefinitionChangeList methodsFor: 'accessing' stamp: 'minami 3/13/2002 11:48'!
atClassNamed: className ifAbsent: aBlock 
	^ self classDefinitionContainerDictionary at: className ifAbsent: aBlock! !


!ClassDefinitionChangeList methodsFor: 'adding' stamp: 'minami 3/13/2002 11:31'!
addDefinition: aClass 
	| className container |
	className := aClass name asString.
	container := self classDefinitionContainerDictionary
				at: className
				ifAbsentPut: [ClassDefinitionRecordContainer new: aClass].
	container
		addFirst: (ClassDefinitionRecord new: aClass).
	self classDefinitionContainerDictionary at: className put: container! !


!ClassDefinitionChangeList methodsFor: 'initialize-release' stamp: 'minami 3/13/2002 11:34'!
initialize
	Cursor wait
		showWhile: [Smalltalk allClasses
				do: [:aClass | 
					self addDefinition: aClass.
					self addDefinition: aClass class]]! !


!ClassDefinitionChangeList methodsFor: 'private' stamp: 'minami 3/13/2002 11:31'!
classDefinitionContainerDictionary
	classDefinitionContainerDictionary isNil
		ifTrue: [classDefinitionContainerDictionary := Dictionary new].
	^ classDefinitionContainerDictionary! !

!ClassDefinitionChangeList methodsFor: 'private' stamp: 'minami 3/13/2002 11:31'!
classDefinitionContainerDictionary: aDictionary 
	classDefinitionContainerDictionary := aDictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassDefinitionChangeList class
	instanceVariableNames: 'default '!

!ClassDefinitionChangeList class methodsFor: 'initialize-release' stamp: 'minami 3/13/2002 11:37'!
initialize
	"ClassDefinitionChangeList initialize"
	default := nil! !


!ClassDefinitionChangeList class methodsFor: 'instance creation' stamp: 'minami 3/13/2002 11:31'!
default
	"ClassDefinitionChangeSet default"
	default isNil
		ifTrue: [default := super new initialize].
	^ default! !


Object subclass: #ClassDefinitionRecord
	instanceVariableNames: 'className timestamp definition '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Changes-Extension'!

!ClassDefinitionRecord methodsFor: 'accessing' stamp: 'minami 3/12/2002 00:35'!
className
	^ className! !

!ClassDefinitionRecord methodsFor: 'accessing' stamp: 'minami 3/12/2002 19:11'!
className: aString
	className := aString! !

!ClassDefinitionRecord methodsFor: 'accessing' stamp: 'minami 3/12/2002 00:35'!
definition
	^ definition! !

!ClassDefinitionRecord methodsFor: 'accessing' stamp: 'minami 3/12/2002 19:27'!
definition: aString 
	definition := aString asString! !

!ClassDefinitionRecord methodsFor: 'accessing' stamp: 'minami 3/12/2002 00:35'!
timestamp
	^ timestamp! !

!ClassDefinitionRecord methodsFor: 'accessing' stamp: 'minami 3/12/2002 00:35'!
timestamp: aDateandTime 
	timestamp := aDateandTime! !


!ClassDefinitionRecord methodsFor: 'printing' stamp: 'minami 3/13/2002 00:51'!
printOn: aStream 
	aStream nextPutAll: self timestamp, ' '.
	aStream nextPutAll: self className! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassDefinitionRecord class
	instanceVariableNames: ''!

!ClassDefinitionRecord class methodsFor: 'instance creation' stamp: 'minami 3/13/2002 00:51'!
new: aClass 
	| record |
	record _ super new.
	record className: aClass name asString.
	record definition: aClass definition.
	record timestamp: Utilities dateStamp.
	^ record! !


Object subclass: #ClassDefinitionRecordContainer
	instanceVariableNames: 'records recordClassName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Changes-Extension'!

!ClassDefinitionRecordContainer methodsFor: 'accessing' stamp: 'minami 3/12/2002 14:37'!
at: anInteger
	^ self records at: anInteger! !

!ClassDefinitionRecordContainer methodsFor: 'accessing' stamp: 'minami 3/12/2002 14:36'!
current
	self records size = 0
		ifTrue: [^ self].
	^ self records first! !

!ClassDefinitionRecordContainer methodsFor: 'accessing' stamp: 'minami 3/12/2002 14:00'!
recordClassName
	^ recordClassName! !

!ClassDefinitionRecordContainer methodsFor: 'accessing' stamp: 'minami 3/12/2002 14:00'!
recordClassName: aString 
	recordClassName := aString! !

!ClassDefinitionRecordContainer methodsFor: 'accessing' stamp: 'minami 3/12/2002 14:01'!
records
	records isNil
		ifTrue: [records := OrderedCollection new].
	^ records! !

!ClassDefinitionRecordContainer methodsFor: 'accessing' stamp: 'minami 3/12/2002 14:02'!
records: anOrderedCollection 
	records := anOrderedCollection! !

!ClassDefinitionRecordContainer methodsFor: 'accessing' stamp: 'minami 3/12/2002 16:28'!
size
	^ self records size! !

!ClassDefinitionRecordContainer methodsFor: 'accessing' stamp: 'minami 3/12/2002 14:39'!
titleList
	^ self records
		collect: [:each | each printString]! !


!ClassDefinitionRecordContainer methodsFor: 'adding' stamp: 'minami 3/13/2002 01:08'!
addFirst: aRecord 
	self size <= 0
		ifTrue: [self records addFirst: aRecord.
			self changed: #records]
		ifFalse: [self current definition = aRecord definition
				ifFalse: [self records addFirst: aRecord.
					self changed: #records]]! !


!ClassDefinitionRecordContainer methodsFor: 'removing' stamp: 'minami 3/12/2002 14:03'!
removeAt: anInteger 
	self records removeAt: anInteger.
	self changed: #records! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassDefinitionRecordContainer class
	instanceVariableNames: ''!

!ClassDefinitionRecordContainer class methodsFor: 'instance creation' stamp: 'minami 3/12/2002 14:00'!
new: aClass 
	| container |
	container := super new.
	container recordClassName: aClass name asString.
	^ container! !


StringHolder subclass: #ClassDefinitionVersionsBrowser
	instanceVariableNames: 'classDefinitionRecordContainer selectedRecordIndex showAsDiffMode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Changes-Extension'!

!ClassDefinitionVersionsBrowser methodsFor: 'interface opening' stamp: 'minami 3/13/2002 23:00'!
open
	Smalltalk isMorphic
		ifTrue: [self openAsMorph]
		ifFalse: [self openAsMVC]! !

!ClassDefinitionVersionsBrowser methodsFor: 'interface opening' stamp: 'minami 3/13/2002 23:00'!
openAsMVC
	| topView versionListView codePainView |
	topView _ StandardSystemView new model: self.
	versionListView _ PluggableListView
				on: self
				list: #recordList
				selected: #selectedRecordIndex
				changeSelected: #selectedRecordIndex:
				menu: #recordListMenu:.
	versionListView window: (0 @ 0 extent: 600 @ 150).
	topView addSubView: versionListView.

	codePainView _ PluggableTextView
				on: self
				text: #contents
				accept: nil
				readSelection: nil
				menu: #codePaneMenu:shifted:.
	codePainView window: (0 @ 0 extent: 600 @ 250).
	topView addSubView: codePainView below: versionListView.

	topView label: self windowLabel.
	topView controller open! !

!ClassDefinitionVersionsBrowser methodsFor: 'interface opening' stamp: 'minami 3/13/2002 23:00'!
openAsMorph
	| topWindow versionListMorph codePainMorph |
	(topWindow _ SystemWindow labelled: self windowLabel) model: self.
	versionListMorph _ PluggableListMorph
				on: self 
				list: #recordList
				selected: #selectedRecordIndex
				changeSelected: #selectedRecordIndex:
				menu: #recordListMenu:.
	topWindow
		addMorph: versionListMorph
		frame: (0.0 @ 0.0 extent: 1 @ 0.3).
	codePainMorph _ PluggableTextMorph
				on: self
				text: #contents
				accept: nil
				readSelection: nil
				menu: #codePaneMenu:shifted:.
	topWindow
		addMorph: codePainMorph
		frame: (0.0 @ 0.3 extent: 1 @ 0.7).
	topWindow openInWorldExtent: 600 @ 400.
	^ topWindow! !


!ClassDefinitionVersionsBrowser methodsFor: 'accessing' stamp: 'minami 3/13/2002 23:00'!
browseClass
	^ Compiler evaluate: self classDefinitionRecordContainer recordClassName! !

!ClassDefinitionVersionsBrowser methodsFor: 'accessing' stamp: 'minami 3/13/2002 23:00'!
classDefinitionRecordContainer
	^ classDefinitionRecordContainer! !

!ClassDefinitionVersionsBrowser methodsFor: 'accessing' stamp: 'minami 3/13/2002 23:00'!
classDefinitionRecordContainer: aClassDefinitionRecordContainer 
	classDefinitionRecordContainer := aClassDefinitionRecordContainer.
	classDefinitionRecordContainer addDependent: self! !

!ClassDefinitionVersionsBrowser methodsFor: 'accessing' stamp: 'minami 3/13/2002 23:00'!
contents
	| index size selectedDefinition |
	index := self selectedRecordIndex.
	size := self classDefinitionRecordContainer size.
	index = 0
		ifTrue: [^ ''].
	selectedDefinition := (self classDefinitionRecordContainer at: self selectedRecordIndex) definition.
	^ self showAsDiffMode
		ifTrue: [(size <= 1
					or: [size <= index])
				ifTrue: [selectedDefinition]
				ifFalse: [self modifiedClassDefinition]]
		ifFalse: [selectedDefinition]! !

!ClassDefinitionVersionsBrowser methodsFor: 'accessing' stamp: 'minami 3/13/2002 23:00'!
showAsDiffMode
	showAsDiffMode isNil
		ifTrue: [showAsDiffMode := true].
	^ showAsDiffMode! !

!ClassDefinitionVersionsBrowser methodsFor: 'accessing' stamp: 'minami 3/13/2002 23:00'!
showAsDiffMode: aBoolean 
	showAsDiffMode := aBoolean.
	self changed: #recordList.
	self changed: #contents! !

!ClassDefinitionVersionsBrowser methodsFor: 'accessing' stamp: 'minami 3/13/2002 23:00'!
windowLabel
	^ ('Recent versions of ' , self classDefinitionRecordContainer recordClassName , ' definition') copy! !


!ClassDefinitionVersionsBrowser methodsFor: 'constants' stamp: 'minami 3/13/2002 23:00'!
defaultBackgroundColor
	^ Color white! !

!ClassDefinitionVersionsBrowser methodsFor: 'constants' stamp: 'minami 3/13/2002 23:00'!
defaultLabelColor
	^ Color veryVeryLightGray! !


!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
browseClassRefs
	| cls |
	(cls := self browseClass)
		ifNotNil: [Smalltalk
				browseAllCallsOn: (Smalltalk associationAt: cls theNonMetaClass name)]! !

!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
browseClassVarRefs
	| cls |
	(cls := self browseClass)
		ifNotNil: [cls browseClassVarRefs]! !

!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
browseClassVariables
	| cls |
	(cls := self browseClass)
		ifNotNil: [cls browseClassVariables]! !

!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
browseInstVarDefs
	| cls |
	(cls := self browseClass)
		ifNotNil: [cls browseInstVarDefs]! !

!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
browseInstVarRefs
	| cls |
	(cls := self browseClass)
		ifNotNil: [cls browseInstVarRefs]! !

!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
browseMethodFull
	| myClass |
	(myClass := self browseClass)
		ifNotNil: [Browser fullOnClass: myClass selector: nil]! !

!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
evaluateSelectedContents
	| viewingDefinition |
	self selectedRecordIndex = 0
		ifTrue: [^ self].
	viewingDefinition := (self classDefinitionRecordContainer at: self selectedRecordIndex) definition.
	self classDefinitionRecordContainer current definition = viewingDefinition
		ifFalse: [Compiler evaluate: viewingDefinition.
			self selectedRecordIndex: 0.
			self changed: #recordList.
			self changed: #contents]! !

!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
recordListMenu: aMenu
	aMenu addList: #(
		-
		('browse full'					browseMethodFull)
		-
		('revert this selected version'	evaluateSelectedContents)
		('remove from changes'			removeFromChanges)
		-
		('inst var refs...'				browseInstVarRefs)
		('inst var defs...'				browseInstVarDefs)
		-
		('class var refs...'				browseClassVarRefs)
		('class vars'						browseClassVariables)
		('class refs'						browseClassRefs)
		-
		('toggle diffing'					toggleDiffing)
		('update list'					updateList)

	).
	^ aMenu! !

!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
removeFromChanges
	self selectedRecordIndex = 0
		ifTrue: [^ self].
	self selectedRecordIndex = 1
		ifTrue: [PopUpMenu inform: 'It''s current version.' , String cr , 'You can not remove'.
			^ self].
	self classDefinitionRecordContainer removeAt: self selectedRecordIndex.
	self selectedRecordIndex: 0.
	self changed: #recordList.
	self changed: #contents! !

!ClassDefinitionVersionsBrowser methodsFor: 'record functions' stamp: 'minami 3/13/2002 23:00'!
updateList
	self changed: #recordList.
	self changed: #contents! !


!ClassDefinitionVersionsBrowser methodsFor: 'record list' stamp: 'minami 3/13/2002 23:00'!
recordList
	^ self classDefinitionRecordContainer titleList! !

!ClassDefinitionVersionsBrowser methodsFor: 'record list' stamp: 'minami 3/13/2002 23:00'!
selectedRecordIndex
	selectedRecordIndex isNil ifTrue: [selectedRecordIndex := 0].
	^ selectedRecordIndex! !

!ClassDefinitionVersionsBrowser methodsFor: 'record list' stamp: 'minami 3/13/2002 23:00'!
selectedRecordIndex: anInteger 
	selectedRecordIndex := anInteger.
	self changed: #recordList.
	self changed: #selectedRecordIndex.
	self changed: #contents! !


!ClassDefinitionVersionsBrowser methodsFor: 'updating' stamp: 'minami 3/13/2002 23:00'!
update: aSymbol 
	self selectedRecordIndex: 0.
	self changed: #recordList.
	self changed: #contents.
	^ super update: aSymbol! !


!ClassDefinitionVersionsBrowser methodsFor: 'diff' stamp: 'minami 3/13/2002 23:00'!
modifiedClassDefinition
	| old new |
	old := (self classDefinitionRecordContainer at: self selectedRecordIndex + 1) definition.
	new := (self classDefinitionRecordContainer at: self selectedRecordIndex) definition.
	^ ClassDiffBuilder buildDisplayPatchFrom: old to: new! !

!ClassDefinitionVersionsBrowser methodsFor: 'diff' stamp: 'minami 3/13/2002 23:00'!
toggleDiffing
	self showAsDiffMode: self showAsDiffMode not.
! !


!ClassDefinitionVersionsBrowser methodsFor: 'private' stamp: 'minami 3/13/2002 23:00'!
selectedMessageCategoryName
	^ nil! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassDefinitionVersionsBrowser class
	instanceVariableNames: ''!

!ClassDefinitionVersionsBrowser class methodsFor: 'instance creation' stamp: 'minami 3/13/2002 23:00'!
fullOnClass: aClass 
	"ClassDefinitionVersionBrowser fullOnClass: ClassDefinitionVersionBrowser"
	| browser container |
	browser := super new.
	container := ClassDefinitionChangeList default
				at: aClass
				ifAbsent: [].
	container isNil
		ifTrue: [ClassDefinitionChangeList default addDefinition: aClass.
			container := ClassDefinitionChangeList default at: aClass].
	browser classDefinitionRecordContainer: container.
	browser open! !

ClassDefinitionChangeList initialize!